SystemOrganization addCategory: #'Rizel-Example'!

TestCase subclass: #MondrianBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Example'!

!MondrianBenchmarks class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovala 6/1/2012 00:57'!
asList
	^ #(#treeLayout #manyNodes #openSimpleGraph #subviews)! !

!MondrianBenchmarks methodsFor: 'benchmarks' stamp: 'JuanPabloSandovalA 6/10/2012 15:12'!
manyNodes
	| view window|
	view := MOViewRenderer new.
	view nodes: (1 to: 2200).
	view root applyLayout.! !

!MondrianBenchmarks methodsFor: 'benchmarks' stamp: 'JuanPabloSandovalA 6/10/2012 15:12'!
openSimpleGraph
	| view window size |
	view := MOViewRenderer new.
	size := 30.
	view nodes: (1 to: size).
	view edges: (1 to: size) from: #yourself toAll: (1 to: size).
	view root applyLayout.! !

!MondrianBenchmarks methodsFor: 'benchmarks' stamp: 'JuanPabloSandovalA 6/10/2012 15:12'!
subviews
	| view limit window|
	view := MOViewRenderer new.
	limit := 50.
	view nodes: (1 to: limit)
			forEach: [:aNumber| 
				view nodes: (1 to: limit).
				view gridLayout].
	view root applyLayout.! !

!MondrianBenchmarks methodsFor: 'benchmarks' stamp: 'JuanPabloSandovalA 6/10/2012 15:13'!
treeLayout
	| view window|
	view := MOViewRenderer new.
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.
	view root applyLayout.! !

TestCase subclass: #RizelDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Example'!

RizelDemo class
	instanceVariableNames: 'mondrianResult xmlResult profileA profileB'!

RizelDemo class
	instanceVariableNames: 'mondrianResult xmlResult profileA profileB'!

!RizelDemo class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/9/2012 17:57'!
mondrianResult 
	^ mondrianResult .! !

!RizelDemo class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/9/2012 17:58'!
mondrianResult: aRzResult
	mondrianResult:= aRzResult.! !

!RizelDemo class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/13/2012 22:06'!
myProfileVersion
	^ myProfileVersion.! !

!RizelDemo class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/13/2012 22:06'!
myProfileVersion: anObject
	myProfileVersion := anObject.! !

!RizelDemo class methodsFor: 'as yet unclassified' stamp: 'JPSA 6/21/2012 01:24'!
profileA
	profileA ifNil:[
	"	|demo|
		demo := RizelDemo new.
		demo loadVersion: (demo mondrianVersions at: 7)."
		profileA := MProfiler profile:[
			MondrianBenchmarks new treeLayout.
			] inPackagesMatching:'Mondrian-*'.
		].
	^ profileA.! !

!RizelDemo class methodsFor: 'as yet unclassified' stamp: 'JPSA 6/21/2012 01:23'!
profileB
	profileB ifNil:[
		"|demo|
		demo := RizelDemo new.
		demo loadVersion: (demo mondrianVersions at: 8)."
		profileB := MProfiler profile:[
			MondrianBenchmarks new treeLayout.
			] inPackagesMatching:'Mondrian-*'.
		].
	^ profileB.! !

!RizelDemo class methodsFor: 'as yet unclassified' stamp: 'JPSA 6/18/2012 21:00'!
reset
	profileA := nil.
	profileB := nil.! !

!RizelDemo class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 15:44'!
xmlResult 
	^ xmlResult .! !

!RizelDemo class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 15:44'!
xmlResult: aRzResult
	xmlResult:= aRzResult.! !

!RizelDemo methodsFor: 'demo' stamp: 'JuanPabloSandovalA 6/9/2012 17:58'!
cache
	^ RizelDemo mondrianResult! !

!RizelDemo methodsFor: 'demo' stamp: 'JuanPabloSandovalA 6/9/2012 17:58'!
cache: aResult 
	^ RizelDemo mondrianResult: aResult! !

!RizelDemo methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/13/2012 22:26'!
fastProfile

	(RzVisualizerDiffGraph on: 
				(Rizel new merge: 
					(RizelDemo myProfileVersion)
				with: (RizelDemo xmlResult values at:4))) visualize.
	! !

!RizelDemo methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 22:04'!
loadVersion: version
	| repo |
  	repo := MCDirectoryRepository new.
  	repo directory: (FileDirectory on: ' /Users/juampi/workspace/Pharo-1-1.4/package-cache/').
  	version repositoryOverrides: (OrderedCollection with: repo).
  	version load.! !

!RizelDemo methodsFor: 'demo' stamp: 'JPSA 6/18/2012 00:09'!
mondrian
	| rizel result lastVersion |
	rizel := Rizel new.
	rizel
		define: #input
		named: #version
		with: (self mondrianVersions).
	rizel
		define: #input
		named: #benchmark
		with: MondrianBenchmarks asList.
	result := self cache.
	result ifNil: [
		result := rizel execute: [:version :benchmark | 
					self loadVersion: version.
					rizel profile: [
						MondrianBenchmarks new perform: benchmark.
					]  inPackagesMatching:'Mondrian-*'.].].
	self cache: result.! !

!RizelDemo methodsFor: 'as yet unclassified' stamp: 'JPSA 6/18/2012 21:45'!
mondrianDiff
	""
	(RzVisualizerDiffGraph on: 
			(Rizel new merge: (RizelDemo profileA) with: (RizelDemo profileB))) visualize! !

!RizelDemo methodsFor: 'demo' stamp: 'JPSA 6/18/2012 00:45'!
mondrianVersions
	|list|
	list:= RizelTest new selectFrom: ((ConfigurationOfMondrian project versions last: 100) reverse) multipleOf:10.
	list removeLast; removeLast.
	^ list asSortedCollection.! !

!RizelDemo methodsFor: 'demo' stamp: 'JuanPabloSandovalA 6/9/2012 17:53'!
quickTest
	"
	RizelDemo new quickTest
	"
	| rizel result |
	rizel := Rizel new.
	rizel
		define: #input
		named: #benchmark
		with: MondrianBenchmarks asList.
	result := rizel
				execute: [ :benchmark | 
							rizel
								profile: [MondrianBenchmarks new perform: benchmark]
								inPackagesMatching: 'Mondrian-*'].
	result inspect.
	
	! !

!RizelDemo methodsFor: 'demo' stamp: 'JuanPabloSandovalA 6/10/2012 15:53'!
xmlCache
	^ RizelDemo xmlResult.! !

!RizelDemo methodsFor: 'demo' stamp: 'JuanPabloSandovalA 6/10/2012 15:53'!
xmlCache: aResult 
	^ RizelDemo xmlResult: aResult! !

!RizelDemo methodsFor: 'demo' stamp: 'JuanPabloSandovalAlcocer 6/11/2012 22:13'!
xmlSupport
	| rizel result |
	rizel := Rizel new.
	rizel
		define: #input
		named: #version
		with: self xmlVersions.
	rizel
		define: #input
		named: #benchmark
		with: XMLBenchmarks asList.
	result := self xmlCache.
	result ifNil: [
		result := MResultSet new.
		rizel execute: [:version :benchmark | 
							self loadVersion: version.
							rizel profile: [
								XMLBenchmarks new perform: benchmark
								] inPackagesMatching: 'XML-*']
			  in: result. 
		self xmlCache: result.]
		ifNotNil:[ rizel openOn: result. ].! !

!RizelDemo methodsFor: 'demo' stamp: 'JuanPabloSandovalA 6/11/2012 13:09'!
xmlVersions
	"
	RizelDemo new xmlVersions
	"
	|list|
	list := (ConfigurationOfXMLSupport project versions last: 10) asSortedCollection removeLast ; yourself.
	^ (list select: [ :version| ('*baseline*' match:(version versionNumber printString)) not]).! !

TestCase subclass: #XMLBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Example'!

!XMLBenchmarks class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/12/2012 00:55'!
asList
	^	#( #elementAt #findElement #saxHandler #xmlDomParser).! !

!XMLBenchmarks methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 15:42'!
addressBookXML
	^'<addressbook>
  <person employee-number="A0000" family-name="Gates" first-name="Bob">
    <contact-info><!!--Confidential--></contact-info>
    <address city="Los Angeles" number="1239" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Manager"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7000" family-name="Brown"
    first-name="Robert" middle-initial="L.">
    <contact-info>
      <email address="robb@iro.ibm.com"/>
      <home-phone number="03-3987873"/>
    </contact-info>
    <address city="New York" number="344" state="NY" street="118 St."/>
    <job-info employee-type="Full-Time" is-manager="yes" job-description="Group Leader"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7890" family-name="DePaiva"
    first-name="Kassie" middle-initial="W.">
    <contact-info><!!-- Kassie''s agent phone: 03-987654 --></contact-info>
    <address city="Los Angeles" number="1234" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Actor"/>
    <manager employee-number="A0000"/>
    <misc-info>One of the most talented actresses on Daytime. Kassie
      plays the devious and beautiful Blair Cramer on ABC&apos;s
      &quot;One Life To Live.&quot;</misc-info>
  </person>
  <person employee-number="A7987" family-name="Smith" first-name="Joe">
    <contact-info>
      <email address="joes@iro.ibm.com"/>
      <mobile-phone number="888-7657765"/>
      <home-phone number="03-8767898"/>
      <home-phone number="03-8767871"/>
    </contact-info>
    <address city="New York" number="12789" state="NY" street="W. 15th Ave."/>
    <job-info employee-type="Part-Time" is-manager="no" job-description="Hacker"/>
    <manager employee-number="A7000"/>
  </person>
</addressbook>
'! !

!XMLBenchmarks methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 22:58'!
elementAt
"
XMLBenchmarks new elementAt 
"
 
	|doc |
	doc := XMLDOMParser
		parseDocumentFrom: self addressBookXML readStream
		useNamespaces: false.
		doc root firstElement
			elementAt: 'contact-info';
			elementAt: 'address';
			elementAt: 'job-info';
			elementAt: 'manager'.
			
	^ doc.! !

!XMLBenchmarks methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 22:56'!
findElement
"
XMLBenchmarks new findElement 
"
 
	|xmlDocument root numberOfPersons firstPerson|
	xmlDocument := XMLDOMParser parse: self addressBookXML.
	root := xmlDocument root.
	root findElementNamed: 'person'.
	root findElementNamed: 'addressbook'.
	root findElementNamed: 'addressbook'.
	numberOfPersons := 0.
	root allElementsNamed: 'person' do: [:p | numberOfPersons := numberOfPersons + 1].
	firstPerson := root findElementNamed: 'person'.
	firstPerson attributeAt: 'employee-number'.
	firstPerson attributeAt: 'family-name'.
	^ xmlDocument.
	! !

!XMLBenchmarks methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 22:56'!
saxHandler
	"
	XMLBenchmarks new saxHandler 
	"
	^  SAXHandler parse: self addressBookXML! !

!XMLBenchmarks methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/10/2012 22:55'!
xmlDomParser
	"
	XMLBenchmarks new xmlDomParser
	"
	^ XMLDOMParser parse: self addressBookXML! !
